'Show a video on TV!
'video data created with special software and stored on SD card
'
'  Brought to you by:  Rayslogic.com
'  The Propeller System Module is coming!  Available Summer 2009.
'
'  'Bitmap buffer fills most of memory...
'  A few routines have been commented out already to save space.

CON

  _clkmode = xtal1 + pll16x
  _xinfreq =5_000_000
  _STACK=40      'going to reserve a little stack space, otherwise things can go very wrong!
  x_tiles = 16
  y_tiles = 12

  SDBase=4              '********   SPECIFY SD Card Base Pin HERE   *****************   


OBJ

  tv    : "TV_PsmVidMod"     'Show pictures on TV!
  sd  : "PSM_SdCardDriver"   'Controls the SD card  
    
DAT  'The Bitmap           

sFilename byte
byte "test.dat",0        '********   SPECIFY Video Filename HERE   *****************

Bitmap long
long    $02030405[160*120/4]

'**********************************************************************************

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64] 

  long  row,col,flag,screensize,rows,cols,color



PUB start | i, pBmp, picBytes, acnt, nframes
  'Start up the modified TV driver and show some text
  'start tv
  longmove(@tv_status, @tvparams, 14)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)   

  rows:=y_tiles
  cols:=x_tiles
  screensize:=rows*cols
  'setcolors(@palette)       'this code commented out to save space, adding the following 2 lines instead...
  colors[0]:=$070A070A
  colors[1]:=$07070a0a
  out(0)
  str(string("TV Video Viewer"))

  'specify parameters
  biWidth:=160
  biHeight:=120 
  picBytes:=(4*((biWidth+3)/4))*biHeight
  'Prepare then show the bitmap
  pBmp:=@Bitmap+160*120'DeIndexColors(@Bitmap)
  'the last color value (63) is used to pass bitmap info to the driver
  colors[63]:=(4*((biWidth+3)/4))<<24+biHeight<<16+pBmp   'pass pointer to BMP

   'You can turn off the bitmap with the following line
'  colors[63]:=0

  'sd.mount(SDBase,SDBase+1,SDBase+2,SDBase+3)
  out(0)
  sd.start
  str(string("Mounting...") )
  if (sd.mount(SDBase,SDBase+1,SDBase+2,SDBase+3)<0)
    out(0)  
    str(string("SD Fail!"))
  else
    out(0)
    str(string("SD Mounted."))

  repeat 1 
    waitcnt(cnt+clkfreq)
    out(0)
    str(string("Opening Video"))
    if (sd.popen(@sFilename,"r")<0)
      out(0)  
      str(string("Open Failed"))
      quit
    else
      out(0)
      str(string("File Open"))
     
    out(0)
    str(string("Playing"))
     
    i:=1
    nframes:=200   '300 'but cnt rolls over after ~30 seconds!  
    acnt:=cnt
    repeat nframes 
      i:=sd.pread(@Bitmap,picBytes)
    acnt:=cnt-acnt
    sd.pclose

    out(0)
    dec(nframes/(acnt/clkfreq))
    str(string(" fps"))

PRI DeIndexColors(pB):bmpAddress|p,i,c,j,bPerfect
  'analyze and prepare bitmap image for display on TV
  p:=pB
  bytemove(@bfType,p,2) 'read bmp header
  p+=2
  bytemove(@bfSize,p,4) 'read bmp header
  p+=4
  bytemove(@bfReserved1,p,4) 'read bmp header
  p+=4
  bytemove(@bfOffBits,p,16) 'read bmp header
  p+=16
  bytemove(@biPlanes,p,4)
  p+=4
  bytemove(@biCompression,p,24)
  p+=24
  'calculate actual bytes in palette
  i:=bfOffBits-54
  'read in palette
  bytemove(@BmpPalette,p,i)
  p+=i
  'create palette translation table
  bPerfect:=bPerfectPalette
  if not bPerfect
    CreatePaletteTranslationTable(i/4)
  'deindex and align colors
  if bPerfect
    repeat j from 1 to biHeight
      repeat i from 1 to 4*((biWidth+3)/4)
        if i=<biWidth
          byte[pB++]:=byte[@TV_Palette][byte[p++]]
        else
          byte[pB++]:=colors[0]
          p++        
  else
     repeat j from 1 to biHeight
      repeat i from 1 to 4*((biWidth+3)/4)         
        if i=<biWidth
          byte[pB++]:=byte[@TV_Palette][long[@BmpPalette][byte[p++]]]
        else
          byte[pB++]:=colors[0]
          p++
            
  return pB-4  

PRI CreatePaletteTranslationTable(n)|i,j,k,emin,e,c,c1,c2,r1,r2
  'If the perfect palette wasn't used, this routine is needed to figure out which colors to use
  repeat i from 0 to n-1
    row:=4
    col:=4
    dec(i)
    emin:=10000000
    c:=0
    c1:=long[@BmpPalette][i] 
    repeat j from 0 to 101      
      c2:=long[@TvPalette][6+j]
      e:=0
      repeat k from 0 to 2
        r1:=byte[@c1][2-k]
        r2:=byte[@c2][k]
        r1:=(r2-r1)
        e+=r1*r1
      if e<emin
        c:=j
        emin:=e
    long[@BmpPalette][i]:=c    
    

PRI bPerfectPalette|i
  'test a few colors to see if my palette is being used
  if long[@BmpPalette][8]<>$003420B1
    return false
  if long[@BmpPalette][53]<>$00D1FF7D
    return false
  if long[@BmpPalette][100]<>$00C691FF
    return false
  return true   

{   
PUB setcolors(colorptr) | i, fore, back

'' Override default color palette
'' colorptr must point to a list of up to 8 colors
'' arranged as follows:
''
''               fore   back
''               ------------
'' palette  byte color, color     'color 0
''          byte color, color     'color 1
''          byte color, color     'color 2
''          ...

  repeat i from 0 to 7
    fore := byte[colorptr][i << 1]
    back := byte[colorptr][i << 1 + 1]
    colors[i << 1]     := fore << 24 + back << 16 + fore << 8 + back
    colors[i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back
}    
    
PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: wordfill(@screen, $220, screensize)
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
  flag := 0

  
PRI print(c)|k,i
      k := color << 1 + c & 1
      i := k << 10 + $200 + c & $FE
      screen[row * cols + col] := i
      screen[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline


PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
    wordfill(@screen[(rows-2)*cols], $220, cols<<1)


PUB str(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10

{ 
PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))

}

DAT       'TV Settings

tvparams                long    0               'status
                        long    1               'enable
                        'long    %010_0101       'pins for Propeller System Module
                        long    %001_0101       'pins for Demo Board
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog



DAT     'Data for reading bitmap files

BMPHeader  byte 'Mostly using info from here:  http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
bfType byte "B","M"  
bfSize long 0
bfReserved1 word 0
bfReserved2 word 0
bfOffBits long 54
biSize long 40
biWidth long 0
biHeight long 10
biPlanes word 1
biBitCount word 24
biCompression long 0
biSizeImage long 0
biXPelsPerMeter long 0
biYPelsPerMeter long 0
biClrUsed long 0
biClrImportant long 0


BmpPalette long 0[256]      'container for bmp palette entries

{
DAT  'text palette
                        '       fore   back
                        '       color  color
palette                 byte    $07,   $0A    '0    white / dark blue
                        byte    $07,   $BB    '1    white / red
                        byte    $9E,   $9B    '2   yellow / brown
                        byte    $04,   $07    '3     grey / white
                        byte    $3D,   $3B    '4     cyan / dark cyan
                        byte    $6B,   $6E    '5    green / gray-green
                        byte    $BB,   $CE    '6      red / pink
                        byte    $3C,   $0A    '7     cyan / blue
}

DAT    'Palette

TV_Palette long
byte    $02,$03,$04,$05,$06,$07
byte    $08,$0A,$0B,$0c,$0d,$0e
byte    $18,$1A,$1B,$1C,$1D,$1E
byte    $28,$2A,$2B,$2C,$2D,$2E
byte    $38,$3A,$3B,$3C,$3D,$3E
byte    $48,$4A,$4B,$4C,$4D,$4E
byte    $58,$5A,$5B,$5C,$5D,$5E
byte    $68,$6A,$6B,$6C,$6D,$6E
byte    $78,$7A,$7B,$7C,$7D,$7E
byte    $88,$8A,$8B,$8C,$8D,$8E
byte    $98,$9A,$9B,$9C,$9D,$9E
byte    $A8,$AA,$AB,$AC,$AD,$AE
byte    $B8,$BA,$BB,$BC,$BD,$BE
byte    $C8,$CA,$CB,$CC,$CD,$CE
byte    $D8,$DA,$DB,$DC,$DD,$DE
byte    $E8,$EA,$EB,$EC,$ED,$EE
byte    $F8,$FA,$FB,$FC,$FD,$FE


DAT
TvPalette long
'file "TvPalette.pal"